#include <stdio.h>
#include <stdlib.h>
#include <string.h>
  FILE *fpin, *fpout;
  char *fnin, *fnout;
global2local(char *buf, char *filename) 
{
    if(strstr(buf, filename) != NULL) {
      printf("%s: replace <%s> with \"%s\"\n", fnin, filename, filename);
      sprintf(buf, "#include \"%s\"\n", filename);
    }
}
main(int argc, char *argv[])
{
#define MAXBUF 512
  char buf[MAXBUF];

  if(argc < 2) {
    printf("usage %s <infile> <outfile>\n", argv[0]);
    return;
  } else {
    fnin = argv[1];
    fnout = argv[2];
  }

  if((fpin = fopen(fnin, "r")) == NULL) {
    printf("error opening infile %s\n", fnin);
    return;
  }
  if((fpout = fopen(fnout, "w")) == NULL) {
    printf("error opening outfile %s\n", fnout);
    return;
  }

#define INCLUDE "#include"
#define SEP "/"
  while(fgets(buf, sizeof(buf), fpin) != NULL) {
    if(strncmp(buf,INCLUDE, sizeof(INCLUDE)-1) == 0 
       && strstr(buf, "/") != NULL 
       && strstr(buf, "<") != NULL) {

      char newbuf[MAXBUF];
      char chgbuf[MAXBUF];
      char *tokprev, *tok;
      char *fnstart;

      printf("%s: modify line: %s", fnin, buf);

      memset(chgbuf, '\0', sizeof(chgbuf));
      memset(newbuf, '\0', sizeof(newbuf));
      memcpy(newbuf, buf, sizeof(newbuf));
      tok = strtok(newbuf, SEP);
      tokprev = tok;
      while(tok != NULL) {
        /* printf("tokn %s ", tok); */
        tokprev = tok;
        tok = strtok(NULL, SEP);
      }
      strcpy(chgbuf, INCLUDE);
      strcat(chgbuf, " ");
      strcat(chgbuf, "<");
      strcat(chgbuf, tokprev);
      strcpy(buf, chgbuf);
      global2local(buf, "xdr.h");
      global2local(buf, "param.h");
      global2local(buf, "fcntl.h");
      global2local(buf, "ioctl.h");
      global2local(buf, "wait.h");
    } /* end mod of include line */

    /** now treat some special includes **/
      
    fputs(buf, fpout);
  } /* end while loop through lines in file */
  fclose(fpin);
  fclose(fpout);

}
